#include <qvalidator.h>

void MainWindow::init(){
    QRegExp regExp("[-]{0,1}\\d*\\.\\d+");
    aInput->setValidator(new QRegExpValidator(regExp, this));
    bInput->setValidator(new QRegExpValidator(regExp, this));
    cInput->setValidator(new QRegExpValidator(regExp, this));    
    
    this->reset();
}

void MainWindow::reset(){
    aInput->setText("1");
    bInput->setText("0");
    cInput->setText("0");    
}

void MainWindow::calculate(){
    equationOutput->setText(aInput->text() + "*X^2 + " + bInput->text() + "*X + " + cInput->text() + " = 0");
    float A = atof(aInput->text());
    float B = atof(bInput->text());
    float C = atof(cInput->text());
    float D = B*B-(4*A*C);
    
    QString tmp;
    QString tmpX;
    QString tmpY;
    
    if(D >= 0){
       if(A == 0){
         x1Output->setText("A must NOT be zero!");
         x2Output->setText("A must NOT be zero!");
       } else {
         float X1 = (-(B)-sqrt(D))/(2*A) ;
         tmp.setNum(X1);
         x1Output->setText(tmp);
   
         float X2 = (-(B)+sqrt(D))/(2*A);
         tmp.setNum(X2);
         x2Output->setText(tmp);
          
         float X = (-B)/(2*A);
         tmpX.setNum(X);
         float Y = (-D)/(4*A);
         tmpY.setNum(Y);
  topPointLabel->setText("X= " + tmpX + "+ Y= " + tmpY);
  
         tmp.setNum(D);
         determinant->setText(tmp);
       }
    } else {
       determinant->setText(tmp);
       x1Output->setText("No reel root");
       x2Output->setText("No reel root");
       topPointLabel->setText("No reel root");
    }
}

void MainWindow::updateALineEdit(){
    aInput->setText(aSpinBox->text());
}

void MainWindow::updateBLineEdit(){
    bInput->setText(bSpinBox->text());
}

void MainWindow::updateCLineEdit(){
    cInput->setText(cSpinBox->text());
}
